???File Path
==========
***...\Src\Assets\AssetsSaleWriteOffDetails.cs\n\n\n

???Check the points
==================



            // ??? IMPORT:- Add the items top - Duplcation Avoid
            using System;
            using System.Data;
            using System.Collections.Generic;
            using Npgsql;
            using NpgsqlTypes;

            using TAAS.Db;
            using TAAS.Models;
            using TAAS.Models.Assets;
            using TAAS.Helpers;
        


            // ??? CLASS ATTRIBUTES:- The code past top of the class(Attributes) - Duplcation Avoid
            public GlobalFunctions insGlobalFunctions = new GlobalFunctions();
            DbService insDbService = new();
        


            public List<MdlBaseIntId> FnGetAllAssetsSaleWriteOffDetailsBaseData()
            {
                List<MdlBaseIntId> lstMdlAssetsSaleWriteOffDetailsBaseIntId = new List<MdlBaseIntId>();

                // Get Data from DB
                DataSet objDataSet = this.insDbService.FnExcecuteSqlCommand("SELECT * FROM fn_get_all_assets_sale_write_off_details()");
                if (objDataSet != null)
                {
                    foreach (DataRow objRecord in objDataSet.Tables[0].Rows)
                    {
                        MdlBaseIntId mdlBaseIntId = new MdlBaseIntId();

                        mdlBaseIntId.binPkId = (DBNull.Value != objRecord["pk_assets_sale_Write_off_id"]) ? (long)Convert.ToUInt64(objRecord["pk_assets_sale_Write_off_id"]) : mdlBaseIntId.binPkId;
                        mdlBaseIntId.strCode = (DBNull.Value != objRecord[""]) ? Convert.ToString(objRecord[""]) : mdlBaseIntId.strCode;
                        mdlBaseIntId.strName = (DBNull.Value != objRecord[""]) ? Convert.ToString(objRecord[""]) : mdlBaseIntId.strName;
        
                        lstMdlAssetsSaleWriteOffDetailsBaseIntId.Add(mdlBaseIntId);
                    }
                }

                return lstMdlAssetsSaleWriteOffDetailsBaseIntId;
            }
        


            public List<MdlAssetsSaleWriteOffDetails> FnGetAllAssetsSaleWriteOffDetailsWithActionUser()
            {
                List<MdlAssetsSaleWriteOffDetails> lstMdlAssetsSaleWriteOffDetails = new List<MdlAssetsSaleWriteOffDetails>();
                
                // Get Data from DB
                DataSet objDataSet = this.insDbService.FnExcecuteSqlCommand("SELECT * FROM fn_get_all_assets_sale_write_off_details_with_action_user()");
                if (objDataSet != null)
                {
                    foreach (DataRow objRecord in objDataSet.Tables[0].Rows)
                    {
                        MdlAssetsSaleWriteOffDetails mdlAssetsSaleWriteOffDetails = new MdlAssetsSaleWriteOffDetails();

                        
				mdlAssetsSaleWriteOffDetails.binAssetsSaleWriteOffId = (DBNull.Value != objRecord["pk_assets_sale_Write_off_id"]) ? (long)Convert.ToInt64(objRecord["pk_assets_sale_Write_off_id"]) : mdlAssetsSaleWriteOffDetails.binAssetsSaleWriteOffId;
				mdlAssetsSaleWriteOffDetails.binAssetsSaleWriteOffMasterId = (DBNull.Value != objRecord["fk_assets_sale_Write_off_master_id"]) ? (long)Convert.ToInt64(objRecord["fk_assets_sale_Write_off_master_id"]) : mdlAssetsSaleWriteOffDetails.binAssetsSaleWriteOffMasterId;

				mdlAssetsSaleWriteOffDetails.binAssetsId = (DBNull.Value != objRecord["fk_assets_id"]) ? (long)Convert.ToInt64(objRecord["fk_assets_id"]) : mdlAssetsSaleWriteOffDetails.binAssetsId;

				mdlAssetsSaleWriteOffDetails.strLedgCurrency = (DBNull.Value != objRecord["vhr_ledg_currency"]) ? Convert.ToString(objRecord["vhr_ledg_currency"]) : mdlAssetsSaleWriteOffDetails.strLedgCurrency;
				mdlAssetsSaleWriteOffDetails.dblLedgCurRoe = (DBNull.Value != objRecord["dbl_ledg_cur_roe"]) ? (double)Convert.ToDouble(objRecord["dbl_ledg_cur_roe"]) : mdlAssetsSaleWriteOffDetails.dblLedgCurRoe;
				mdlAssetsSaleWriteOffDetails.dblLedgCurPrice = (DBNull.Value != objRecord["dbl_ledg_cur_price"]) ? (double)Convert.ToDouble(objRecord["dbl_ledg_cur_price"]) : mdlAssetsSaleWriteOffDetails.dblLedgCurPrice;
				mdlAssetsSaleWriteOffDetails.dblLedgCurProfit = (DBNull.Value != objRecord["dbl_ledg_cur_profit"]) ? (double)Convert.ToDouble(objRecord["dbl_ledg_cur_profit"]) : mdlAssetsSaleWriteOffDetails.dblLedgCurProfit;

				mdlAssetsSaleWriteOffDetails.strBaseCurrency = (DBNull.Value != objRecord["vhr_base_currency"]) ? Convert.ToString(objRecord["vhr_base_currency"]) : mdlAssetsSaleWriteOffDetails.strBaseCurrency;
				mdlAssetsSaleWriteOffDetails.dblBaseCurPrice = (DBNull.Value != objRecord["dbl_base_cur_price"]) ? (double)Convert.ToDouble(objRecord["dbl_base_cur_price"]) : mdlAssetsSaleWriteOffDetails.dblBaseCurPrice;
				mdlAssetsSaleWriteOffDetails.dblBaseCurProfit = (DBNull.Value != objRecord["dbl_base_cur_profit"]) ? (double)Convert.ToDouble(objRecord["dbl_base_cur_profit"]) : mdlAssetsSaleWriteOffDetails.dblBaseCurProfit;

				mdlAssetsSaleWriteOffDetails.strAssetsLedgCurrency = (DBNull.Value != objRecord["vhr_assets_ledg_currency"]) ? Convert.ToString(objRecord["vhr_assets_ledg_currency"]) : mdlAssetsSaleWriteOffDetails.strAssetsLedgCurrency;
				mdlAssetsSaleWriteOffDetails.dblAssetsLedgCurRoe = (DBNull.Value != objRecord["dbl_assets_ledg_cur_roe"]) ? (double)Convert.ToDouble(objRecord["dbl_assets_ledg_cur_roe"]) : mdlAssetsSaleWriteOffDetails.dblAssetsLedgCurRoe;
				mdlAssetsSaleWriteOffDetails.dblAssetsLedgCurCurrentValue = (DBNull.Value != objRecord["dbl_assets_ledg_cur_current_value"]) ? (double)Convert.ToDouble(objRecord["dbl_assets_ledg_cur_current_value"]) : mdlAssetsSaleWriteOffDetails.dblAssetsLedgCurCurrentValue;
				mdlAssetsSaleWriteOffDetails.dblAssetsLedgCurProfit = (DBNull.Value != objRecord["dbl_assets_ledg_cur_profit"]) ? (double)Convert.ToDouble(objRecord["dbl_assets_ledg_cur_profit"]) : mdlAssetsSaleWriteOffDetails.dblAssetsLedgCurProfit;

				mdlAssetsSaleWriteOffDetails.strAssetsBaseCurrency = (DBNull.Value != objRecord["vhr_assets_base_currency"]) ? Convert.ToString(objRecord["vhr_assets_base_currency"]) : mdlAssetsSaleWriteOffDetails.strAssetsBaseCurrency;
				mdlAssetsSaleWriteOffDetails.dblAssetsBaseCurCurrentValue = (DBNull.Value != objRecord["dbl_assets_base_cur_current_value"]) ? (double)Convert.ToDouble(objRecord["dbl_assets_base_cur_current_value"]) : mdlAssetsSaleWriteOffDetails.dblAssetsBaseCurCurrentValue;
				mdlAssetsSaleWriteOffDetails.dblAssetsBaseCurProfit = (DBNull.Value != objRecord["dbl_assets_base_cur_profit"]) ? (double)Convert.ToDouble(objRecord["dbl_assets_base_cur_profit"]) : mdlAssetsSaleWriteOffDetails.dblAssetsBaseCurProfit;

				mdlAssetsSaleWriteOffDetails.sinSalesCount = (DBNull.Value != objRecord["sin_sales_count"]) ? (short)Convert.ToInt16(objRecord["sin_sales_count"]) : mdlAssetsSaleWriteOffDetails.sinSalesCount;
				mdlAssetsSaleWriteOffDetails.sinAssetsPreviousStatus = (DBNull.Value != objRecord["sin_assets_previous_status"]) ? (short)Convert.ToInt16(objRecord["sin_assets_previous_status"]) : mdlAssetsSaleWriteOffDetails.sinAssetsPreviousStatus;


        
                        lstMdlAssetsSaleWriteOffDetails.Add(mdlAssetsSaleWriteOffDetails);
                    }
                }

                return lstMdlAssetsSaleWriteOffDetails;
            }
        


            public MdlResAssetsSaleWriteOffDetails FnInsertOrUpdateAssetsSaleWriteOffDetails(MdlReqAssetsSaleWriteOffDetails mdlReqAssetsSaleWriteOffDetails)
            {
                // *** Input Validation INSERT and UPDATE Case[not duplicate model validation]
                // ??? Duplication Checking in DB FUCTION(Insert and Update) - CODE, NAME [, other unique fields] Already exists
                // ??? Count Exced or other checking License related in DB FUCTION(Insert)
                // ??? UPDATE Check already update another users in DB FUCTION(Update and Delete)

                // Set Create or modified User in DB FUCTION(Insert, Update and Delete)
                if (mdlReqAssetsSaleWriteOffDetails.mdlAssetsSaleWriteOffDetails.binAssetsSaleWriteOffId == 0)
                {
                    mdlReqAssetsSaleWriteOffDetails.mdlAssetsSaleWriteOffDetails.intSysActionId = 0;
                    mdlReqAssetsSaleWriteOffDetails.mdlAssetsSaleWriteOffDetails.binCreatedUserId = mdlReqAssetsSaleWriteOffDetails.linLoginUserId;
                    mdlReqAssetsSaleWriteOffDetails.mdlAssetsSaleWriteOffDetails.strCreatedUser = mdlReqAssetsSaleWriteOffDetails.strLoginUserName;
                    mdlReqAssetsSaleWriteOffDetails.mdlAssetsSaleWriteOffDetails.dtmCreated = mdlReqAssetsSaleWriteOffDetails.dtmCurrentDateTime;
                }
                else {
                    mdlReqAssetsSaleWriteOffDetails.mdlAssetsSaleWriteOffDetails.binLastModifiedUserId = mdlReqAssetsSaleWriteOffDetails.linLoginUserId;
                    mdlReqAssetsSaleWriteOffDetails.mdlAssetsSaleWriteOffDetails.strLastModifiedUser = mdlReqAssetsSaleWriteOffDetails.strLoginUserName;
                    mdlReqAssetsSaleWriteOffDetails.mdlAssetsSaleWriteOffDetails.dtmLastModified = mdlReqAssetsSaleWriteOffDetails.dtmCurrentDateTime;
                }

                // DB Actions
                NpgsqlParameter[] lstSqlParameter = {
                    new NpgsqlParameter("mdlAssetsSaleWriteOffDetails", NpgsqlDbType.Jsonb) { Value = mdlReqAssetsSaleWriteOffDetails.mdlAssetsSaleWriteOffDetails, DataTypeName = "jsnAssetsSaleWriteOffDetails"},
                    new NpgsqlParameter("jsnSqlRes", NpgsqlDbType.Json) { DataTypeName = "jsnSqlRes", Direction = ParameterDirection.Output }
                };
                MdlDbResponse mdlDbResponse = this.insDbService.FnExcecuteOutSqlCommand("CALL sp_insert_or_update_assetsSaleWriteOffDetails(:mdlAssetsSaleWriteOffDetails, NULL)", lstSqlParameter);
                // DB Error
                if (mdlDbResponse.sinSqlCustomStatus != 1)
                {
                    if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_ERROR")
                    {
                        throw (new TaasDatabaseException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "ASSETSSALEWRITEOFFDETAILS.CS#004", mdlDbResponse.strSqlSysMessage)));
                    }
                    else if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_VALIDATION_ERROR")
                    {
                        throw (new TaasDatabaseValidationException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "ASSETSSALEWRITEOFFDETAILS.CS#002", mdlDbResponse.strSqlSysMessage)));
                    }
                    else if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_SYSTEM_ERROR")
                    {
                        throw (new TaasDatabaseException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "ASSETSSALEWRITEOFFDETAILS.CS#003", mdlDbResponse.strSqlSysMessage)));
                    }
                }

                // Saved
                MdlResAssetsSaleWriteOffDetails mdlResAssetsSaleWriteOffDetails = new MdlResAssetsSaleWriteOffDetails();
                mdlResAssetsSaleWriteOffDetails.mdlAssetsSaleWriteOffDetails = mdlAssetsSaleWriteOffDetailsReq.mdlAssetsSaleWriteOffDetails;
                if (mdlReqAssetsSaleWriteOffDetails.mdlAssetsSaleWriteOffDetails.binAssetsSaleWriteOffId == 0)
                {
                    mdlResAssetsSaleWriteOffDetails.mdlAssetsSaleWriteOffDetails.binAssetsSaleWriteOffId = mdlDbResponse.binSqlPk ?? 0;
                    mdlResAssetsSaleWriteOffDetails.mdlAssetsSaleWriteOffDetails.dtmCreated = mdlDbResponse.dtmCurrent;
                }
                else
                {
                    mdlResAssetsSaleWriteOffDetails.mdlAssetsSaleWriteOffDetails.intSysActionId += 1;
                    mdlResAssetsSaleWriteOffDetails.mdlAssetsSaleWriteOffDetails.dtmLastModified = mdlDbResponse.dtmCurrent;
                }
                mdlResAssetsSaleWriteOffDetails.sinStatus = 1;
                mdlResAssetsSaleWriteOffDetails.strStatusCode = "SUCCESS";
                mdlResAssetsSaleWriteOffDetails.strMessage = "ASSETSSALEWRITEOFFDETAILS has been Saved.";
                
                return mdlResAssetsSaleWriteOffDetails;
            } 
        


            public MdlResBaseIntId FnDeleteAssetsSaleWriteOffDetails(MdlReqBaseIntId mdlReqAssetsSaleWriteOffDetailsBaseIntId)
            {
                // *** Input Validation DELETE Case[not duplicate model validation]
                // ??? FOREIGN KEY REFERENCES Ching in DB FUCTION(Delete)
                // ??? UPDATE Check already update another users in DB FUCTION(Update and Delete)
                // ??? Set Create or modified User in DB FUCTION(Insert, Update and Delete)

                // DB Actions
                NpgsqlParameter[] lstSqlParameter = {
                    new NpgsqlParameter("binAssetsSaleWriteOffId", NpgsqlDbType.Bigint) { Value = mdlReqAssetsSaleWriteOffDetailsBaseIntId.mdlBaseIntId.binPkId, DataTypeName = "binAssetsSaleWriteOffId"},
                    new NpgsqlParameter("intSysActionId", NpgsqlDbType.Integer) { Value = mdlReqAssetsSaleWriteOffDetailsBaseIntId.mdlBaseIntId.binCustomValue, DataTypeName = "intSysActionId"},
                    new NpgsqlParameter("binDeletedUserId", NpgsqlDbType.Bigint) { Value = mdlReqAssetsSaleWriteOffDetailsBaseIntId.linLoginUserId, DataTypeName = "binDeletedUserId"},
                    new NpgsqlParameter("jsnSqlRes", NpgsqlDbType.Json) { DataTypeName = "jsnSqlRes", Direction = ParameterDirection.Output }
                };
                MdlDbResponse mdlDbResponse = this.insDbService.FnExcecuteOutSqlCommand("CALL sp_delete_assetsSaleWriteOffDetails(:binAssetsSaleWriteOffId, :intSysActionId, :binDeletedUserId, NULL)", lstSqlParameter);
                // DB Error
                if (mdlDbResponse.sinSqlCustomStatus != 1)
                {
                    if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_ERROR")
                    {
                        throw (new TaasDatabaseException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "ASSETSSALEWRITEOFFDETAILS.CS#004", mdlDbResponse.strSqlSysMessage)));
                    }
                    else if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_VALIDATION_ERROR")
                    {
                        throw (new TaasDatabaseValidationException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "ASSETSSALEWRITEOFFDETAILS.CS#005", mdlDbResponse.strSqlSysMessage)));
                    }
                    else if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_SYSTEM_ERROR")
                    {
                        throw (new TaasDatabaseException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "ASSETSSALEWRITEOFFDETAILS.CS#006", mdlDbResponse.strSqlSysMessage)));
                    }
                }

                // Deleted
                MdlResBaseIntId mdlResAssetsSaleWriteOffDetailsIntId = new MdlResBaseIntId();

                mdlResAssetsSaleWriteOffDetailsIntId.mdlBaseIntId = mdlReqAssetsSaleWriteOffDetailsBaseIntId.mdlBaseIntId;
                mdlResAssetsSaleWriteOffDetailsIntId.sinStatus = 1;
                mdlResAssetsSaleWriteOffDetailsIntId.strStatusCode = "SUCCESS";
                mdlResAssetsSaleWriteOffDetailsIntId.strMessage = "ASSETSSALEWRITEOFFDETAILS has been deleted.";

                return mdlResAssetsSaleWriteOffDetailsIntId;
            }
        

