???File Path
==========
***...\Controllers\AssetsController.cs\n\n\n

???Check the points
==================
1) Set Error code no -> assets_CONTROLLER.CS#??? 



            // ??? Add the items top - Duplcation Avoid
            using System;
            using System.Data;
            using Newtonsoft.Json;
            using System.Linq;
            using Npgsql;
            using NpgsqlTypes;

            using TAAS.Helpers;
            using TAAS.Db;
            using TAAS.Models;
            using TAAS.Models.Assets;
            using TAAS.Src.Assets;
        


            // ??? The code past top of the class(Attributes) - Duplcation Avoid
            public GlobalFunctions insGlobalFunctions = new GlobalFunctions();
            DbService insDbService = new DbService();
            AssetsSaleWriteOffDetails insAssetsSaleWriteOffDetails = new AssetsSaleWriteOffDetails();
        


            [HttpGet("GetAssetsSaleWriteOffDetailsInitializeData")]
            public IActionResult GetAssetsSaleWriteOffDetailsInitializeData()
            {
                try
                {
                    // &&& Get Data from Header
                    long linLoginUserId = Convert.ToInt64(Request.Headers["linLoginUserId"]);
                    //string strLoginUserName = Request.Headers["strLoginUserName"];
                    string strSysModuleName = Request.Headers["strSysModuleName"];
                    //var dtmCurrentDateTime = DateTime.Now;

                    // *** Authentication Checking
                    if (linLoginUserId == 0) {
                        throw (new TaasAuthenticationException(this.insGlobalFunctions.FnGetExceptionResponseString("Login User Authentication Failed.", "ASSETS_CONTROLLER.CS#001")));
                    }

                    // *** VIEW - User Permission Checking
                    string strAction = "VIEW";
                    NpgsqlParameter[] lstSqlParameter = {
                        new NpgsqlParameter("linLoginUserId", NpgsqlDbType.Bigint) { Value = linLoginUserId, DataTypeName = "linLoginUserId"},
                        new NpgsqlParameter("vhrSysModuleName", NpgsqlDbType.Varchar, 250) { Value = strSysModuleName, DataTypeName = "vhrSysModuleName"},
                        new NpgsqlParameter("vhrAction", NpgsqlDbType.Varchar, 50) { Value = strAction, DataTypeName = "vhrAction"},
                    };
                    DataSet objDataSet = this.insDbService.FnExcecuteSqlCommand("SELECT * FROM fn_check_user_permission(:linLoginUserId, :vhrSysModuleName, :vhrAction)",  lstSqlParameter);
                    if (objDataSet != null && Convert.ToInt16(objDataSet.Tables[0].Rows[0]["sin_sql_check_status"]) == -1)
                    {
                        throw (new TaasUserPermissionException(this.insGlobalFunctions.FnGetExceptionResponseString("You have no Permission to AssetsSaleWriteOffDetails VIEW.", "ASSETS_CONTROLLER.CS#002")));
                    }

                    MdlResAssetsSaleWriteOffDetailsInit mdlResAssetsSaleWriteOffDetailsInit = new MdlResAssetsSaleWriteOffDetailsInit();

                    // ??? Check and Rename or Remove If unwanted codes
			AssetsSaleWriteOffMaster insAssetsSaleWriteOffMaster = new AssetsSaleWriteOffMaster();
			mdlResAssetsSaleWriteOffDetailsInit.lstMdlAssetsSaleWriteOffMasterBaseIntId = insAssetsSaleWriteOffMaster.FnGetAllAssetsSaleWriteOffMasterKeyIntValue();
			Assets insAssets = new Assets();
			mdlResAssetsSaleWriteOffDetailsInit.lstMdlAssetsBaseIntId = insAssets.FnGetAllAssetsKeyIntValue();

                    // AssetsSaleWriteOffDetails List
                    mdlResAssetsSaleWriteOffDetailsInit.lstMdlAssetsSaleWriteOffDetails = this.insAssetsSaleWriteOffDetails.FnGetAllAssetsSaleWriteOffDetailsWithActionUser();

                    return Ok(mdlResAssetsSaleWriteOffDetailsInit);
                }
                
                catch (TaasAuthenticationException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "AUTHENTICATION_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "Authentication Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasUserPermissionException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "USER_PERMISSION_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AssetsSaleWriteOffDetails User Permission Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasModelValidationException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "MODEL_VALIDATION_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AssetsSaleWriteOffDetails Model Validation Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasValidationException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "VALIDATION_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AssetsSaleWriteOffDetails Validation Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasLogicalException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "LOGICAL_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AssetsSaleWriteOffDetails Logical Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasSystemException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "SYSTEM_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AssetsSaleWriteOffDetails System Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasDatabaseException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "DATABASE_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AssetsSaleWriteOffDetails Database Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasDatabaseValidationException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "DATABASE_VALIDATION_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AssetsSaleWriteOffDetails Database Validation Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasNoDataException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "NO_DATA_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AssetsSaleWriteOffDetails No Data Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasDatabaseSystemException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "DATABASE_SYSTEM_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AssetsSaleWriteOffDetails Database System Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AssetsSaleWriteOffDetails Taas Error.";

                    return Ok(mdlResponse);
                }
                catch (Exception ex)
                {
                    MdlResponse mdlResponse = new MdlResponse();

                    mdlResponse.sinStatus = -1;
                    mdlResponse.strStatusCode = "ERROR";
                    mdlResponse.strErrorType = "SYSTEM_ERROR";
                    mdlResponse.strErrorCode = "ASSETS_CONTROLLER.CS#001";
                    mdlResponse.strMessage = "AssetsSaleWriteOffDetails Error.";
                    mdlResponse.strSysError = ex.Message;

                    return Ok(mdlResponse);
                }

        
            }
        


            [HttpPost("SaveAssetsSaleWriteOffDetails")]
            public IActionResult SaveAssetsSaleWriteOffDetails([FromBody] MdlReqAssetsSaleWriteOffDetails mdlReqAssetsSaleWriteOffDetails)
            {
                try
                {
                    // &&& Get Data from Header
                    mdlReqAssetsSaleWriteOffDetails.linLoginUserId = Convert.ToInt64(Request.Headers["linLoginUserId"]);
                    mdlReqAssetsSaleWriteOffDetails.strLoginUserName = Request.Headers["strLoginUserName"];
                    mdlReqAssetsSaleWriteOffDetails.strSysModuleName = Request.Headers["strSysModuleName"];
                    mdlReqAssetsSaleWriteOffDetails.dtmCurrentDateTime = DateTime.Now;

                    // *** Authentication
                    if (mdlReqAssetsSaleWriteOffDetails.linLoginUserId == 0) {
                        throw (new TaasAuthenticationException(this.insGlobalFunctions.FnGetExceptionResponseString("Login User Authentication Failed.", "ASSETS_CONTROLLER.CS#003")));
                    }

                    // *** ADD/UPDATE - User Permission Checking
                    string strAction = "ADD";
                    if (mdlReqAssetsSaleWriteOffDetails.mdlAssetsSaleWriteOffDetails.binAssetsSaleWriteOffId > 0) 
                    {
                        strAction = "EDIT";
                    }
                    NpgsqlParameter[] lstSqlParameter = {
                        new NpgsqlParameter("linLoginUserId", NpgsqlDbType.Bigint) { Value = mdlReqAssetsSaleWriteOffDetails.linLoginUserId, DataTypeName = "linLoginUserId"},
                        new NpgsqlParameter("vhrSysModuleName", NpgsqlDbType.Varchar, 250) { Value = mdlReqAssetsSaleWriteOffDetails.strSysModuleName, DataTypeName = "vhrSysModuleName"},
                        new NpgsqlParameter("vhrAction", NpgsqlDbType.Varchar, 50) { Value = strAction, DataTypeName = "vhrAction"},
                    };
                    DataSet objDataSet = this.insDbService.FnExcecuteSqlCommand("SELECT * FROM fn_check_user_permission(:linLoginUserId, :vhrSysModuleName, :vhrAction)",  lstSqlParameter);
                    if (objDataSet != null && Convert.ToInt16(objDataSet.Tables[0].Rows[0]["sin_sql_check_status"]) == -1)
                    {
                        throw (new TaasUserPermissionException(this.insGlobalFunctions.FnGetExceptionResponseString("You have no Permission to AssetsSaleWriteOffDetails ADD/UPDATE.", "ASSETS_CONTROLLER.CS#004")));
                    }

                    // !!! Model Validation
                    if (!ModelState.IsValid)
                    {
                        string strMdlValidationErrors = String.Join("; ", ModelState.Values.SelectMany(objStateValue => objStateValue.Errors)
                                    .Select(objStateError => objStateError.ErrorMessage)
                                    .ToList());
                        throw (new TaasModelValidationException(this.insGlobalFunctions.FnGetExceptionResponseString(strMdlValidationErrors, "ASSETS_CONTROLLER.CS#005")));
                    }

                    // @@@ Decrypt
                    
                    // ### Save
                    MdlResAssetsSaleWriteOffDetails mdlResAssetsSaleWriteOffDetails = this.insAssetsSaleWriteOffDetails.FnInsertOrUpdateAssetsSaleWriteOffDetails(mdlReqAssetsSaleWriteOffDetails);

                    return Ok(mdlResAssetsSaleWriteOffDetails);
                }
                
                catch (TaasAuthenticationException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "AUTHENTICATION_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "Authentication Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasUserPermissionException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "USER_PERMISSION_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AssetsSaleWriteOffDetails User Permission Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasModelValidationException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "MODEL_VALIDATION_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AssetsSaleWriteOffDetails Model Validation Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasValidationException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "VALIDATION_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AssetsSaleWriteOffDetails Validation Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasLogicalException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "LOGICAL_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AssetsSaleWriteOffDetails Logical Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasSystemException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "SYSTEM_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AssetsSaleWriteOffDetails System Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasDatabaseException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "DATABASE_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AssetsSaleWriteOffDetails Database Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasDatabaseValidationException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "DATABASE_VALIDATION_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AssetsSaleWriteOffDetails Database Validation Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasNoDataException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "NO_DATA_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AssetsSaleWriteOffDetails No Data Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasDatabaseSystemException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "DATABASE_SYSTEM_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AssetsSaleWriteOffDetails Database System Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AssetsSaleWriteOffDetails Taas Error.";

                    return Ok(mdlResponse);
                }
                catch (Exception ex)
                {
                    MdlResponse mdlResponse = new MdlResponse();

                    mdlResponse.sinStatus = -1;
                    mdlResponse.strStatusCode = "ERROR";
                    mdlResponse.strErrorType = "SYSTEM_ERROR";
                    mdlResponse.strErrorCode = "ASSETS_CONTROLLER.CS#001";
                    mdlResponse.strMessage = "AssetsSaleWriteOffDetails Error.";
                    mdlResponse.strSysError = ex.Message;

                    return Ok(mdlResponse);
                }

        
            }
        


            [HttpPost("DeleteAssetsSaleWriteOffDetails")]
            public IActionResult DeleteAssetsSaleWriteOffDetails([FromBody] MdlReqBaseIntId mdlReqAssetsSaleWriteOffDetailsBaseIntId)
            {
                try
                {
                    // &&& Get Data from Header
                    mdlReqAssetsSaleWriteOffDetailsBaseIntId.linLoginUserId = Convert.ToInt64(Request.Headers["linLoginUserId"]);
                    mdlReqAssetsSaleWriteOffDetailsBaseIntId.strLoginUserName = Request.Headers["strLoginUserName"];
                    mdlReqAssetsSaleWriteOffDetailsBaseIntId.strSysModuleName = Request.Headers["strSysModuleName"];
                    mdlReqAssetsSaleWriteOffDetailsBaseIntId.dtmCurrentDateTime = DateTime.Now;

                    // *** Authentication
                    if (mdlReqAssetsSaleWriteOffDetailsBaseIntId.linLoginUserId == 0) {
                        throw (new TaasAuthenticationException(this.insGlobalFunctions.FnGetExceptionResponseString("Login User Authentication Failed.", "ASSETS_CONTROLLER.CS#006")));
                    }

                    // *** DELETE - User Permission Checking
                    string strAction = "DELETE";
                    NpgsqlParameter[] lstSqlParameter = {
                        new NpgsqlParameter("linLoginUserId", NpgsqlDbType.Bigint) { Value = mdlReqAssetsSaleWriteOffDetailsBaseIntId.linLoginUserId, DataTypeName = "linLoginUserId"},
                        new NpgsqlParameter("vhrSysModuleName", NpgsqlDbType.Varchar, 250) { Value = mdlReqAssetsSaleWriteOffDetailsBaseIntId.strSysModuleName, DataTypeName = "vhrSysModuleName"},
                        new NpgsqlParameter("vhrAction", NpgsqlDbType.Varchar, 50) { Value = strAction, DataTypeName = "vhrAction"},
                    };
                    DataSet objDataSet = this.insDbService.FnExcecuteSqlCommand("SELECT * FROM fn_check_user_permission(:linLoginUserId, :vhrSysModuleName, :vhrAction)",  lstSqlParameter);
                    if (objDataSet != null && Convert.ToInt16(objDataSet.Tables[0].Rows[0]["sin_sql_check_status"]) == -1)
                    {
                        throw (new TaasUserPermissionException(this.insGlobalFunctions.FnGetExceptionResponseString("You have no Permission to AssetsSaleWriteOffDetails DELETE.", "ASSETS_CONTROLLER.CS#007")));
                    }

                    // @@@ Decrypt
                    
                    // ### Delete
                    MdlResponse mdlResponse = this.insAssetsSaleWriteOffDetails.FnDeleteAssetsSaleWriteOffDetails(mdlReqAssetsSaleWriteOffDetailsBaseIntId);

                    return Ok(mdlResponse);
                }
                
                catch (TaasAuthenticationException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "AUTHENTICATION_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "Authentication Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasUserPermissionException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "USER_PERMISSION_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AssetsSaleWriteOffDetails User Permission Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasModelValidationException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "MODEL_VALIDATION_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AssetsSaleWriteOffDetails Model Validation Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasValidationException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "VALIDATION_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AssetsSaleWriteOffDetails Validation Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasLogicalException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "LOGICAL_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AssetsSaleWriteOffDetails Logical Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasSystemException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "SYSTEM_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AssetsSaleWriteOffDetails System Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasDatabaseException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "DATABASE_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AssetsSaleWriteOffDetails Database Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasDatabaseValidationException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "DATABASE_VALIDATION_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AssetsSaleWriteOffDetails Database Validation Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasNoDataException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "NO_DATA_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AssetsSaleWriteOffDetails No Data Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasDatabaseSystemException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "DATABASE_SYSTEM_ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AssetsSaleWriteOffDetails Database System Error.";

                    return Ok(mdlResponse);
                }
                catch (TaasException ex)
                {
                    MdlResponse mdlResponse = JsonConvert.DeserializeObject<MdlResponse>(ex.Message);
                    mdlResponse.strErrorType = "ERROR";
                    mdlResponse.strMessage = mdlResponse.strMessage ?? "AssetsSaleWriteOffDetails Taas Error.";

                    return Ok(mdlResponse);
                }
                catch (Exception ex)
                {
                    MdlResponse mdlResponse = new MdlResponse();

                    mdlResponse.sinStatus = -1;
                    mdlResponse.strStatusCode = "ERROR";
                    mdlResponse.strErrorType = "SYSTEM_ERROR";
                    mdlResponse.strErrorCode = "ASSETS_CONTROLLER.CS#001";
                    mdlResponse.strMessage = "AssetsSaleWriteOffDetails Error.";
                    mdlResponse.strSysError = ex.Message;

                    return Ok(mdlResponse);
                }

        
            }
        

