???File Path
==========
***...\ClientApp\src\app\models\base\assets.model.ts\n\n\n// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
// @@@@@@@@@@@  AssetsSaleWriteOffMaster  @@@@@@@@@@@
// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
export class MdlAssetsSaleWriteOffMaster {

	binAssetsSaleWriteOffMasterId: number = 0;
	binDocumentsId: number = 0;
	strDocuments: string = "";
	binDepreciationMasterId: number | null = null;
	strDepreciationMaster: string = "";
	
	binCostCentreId: number | null = null;
	strCostCentre: string = "";
	sinIfSale: number = 1;
	
	binReceivedChequeId: number | null = null;
	strReceivedCheque: string = "";
	binCcSwapId: number | null = null;
	strCcSwap: string = "";
	strDepositorName: string = "";
	strDepositorRefNo: string = "";
	
	strPayeeVpa: string = "";
	strPayeeVpaBank: string = "";
	
	strVirtualNumber: string = "";
	strVirtualProvider: string = "";
	strVirtualReference: string = "";
	
	strLedgCurrency: string = "";
	dblLedgCurRoe: number = 1.00;
	dblLedgCurAmount: number = 0.0;
	dblLedgCurBankCharge: number = 0.0;
	
	strBaseCurrency: string = "";
	dblBaseCurAmount: number = 0.0;
	dblBaseCurBankCharge: number = 0.0;
	
	binServiceTaxId: number | null = null;
	strServiceTax: string = "";
	dblSysPerceOfTax: number = 0.0;
	dblPerceOfTax: number = 0.0;
	dblLedgCurTaxBaseAmount: number = 0.0;
	dblLedgCurTaxAmount: number = 0.0;
	
	dblBaseCurTaxBaseAmount: number = 0.0;
	dblBaseCurTaxAmount: number = 0.0;
	
}

export class MdlReqAssetsSaleWriteOffMaster extends MdlRequest {

	mdlAssetsSaleWriteOffMaster:MdlAssetsSaleWriteOffMaster = new MdlAssetsSaleWriteOffMaster();
}

export class MdlResAssetsSaleWriteOffMaster extends MdlResponse {

	mdlAssetsSaleWriteOffMaster:MdlAssetsSaleWriteOffMaster = new MdlAssetsSaleWriteOffMaster();
}

export class MdlResAssetsSaleWriteOffMasterList extends MdlResponse {

	lstMdlAssetsSaleWriteOffMaster: MdlAssetsSaleWriteOffMaster[] = [];
}

export class MdlResAssetsSaleWriteOffMasterInit extends MdlResponse {
	lstMdlDocumentsBaseIntId: MdlBaseIntId[] = [];
	lstMdlDepreciationMasterBaseIntId: MdlBaseIntId[] = [];
	lstMdlCostCentreBaseIntId: MdlBaseIntId[] = [];
	lstMdlReceivedChequeBaseIntId: MdlBaseIntId[] = [];
	lstMdlCcSwapBaseIntId: MdlBaseIntId[] = [];
	lstMdlServiceTaxBaseIntId: MdlBaseIntId[] = [];


	lstMdlAssetsSaleWriteOffMaster: MdlAssetsSaleWriteOffMaster[] = [];
}

