???File Path
==========
***...\Src\Assets\AssetsSaleWriteOffMaster.cs\n\n\n

???Check the points
==================



            // ??? IMPORT:- Add the items top - Duplcation Avoid
            using System;
            using System.Data;
            using System.Collections.Generic;
            using Npgsql;
            using NpgsqlTypes;

            using TAAS.Db;
            using TAAS.Models;
            using TAAS.Models.Assets;
            using TAAS.Helpers;
        


            // ??? CLASS ATTRIBUTES:- The code past top of the class(Attributes) - Duplcation Avoid
            public GlobalFunctions insGlobalFunctions = new GlobalFunctions();
            DbService insDbService = new();
        


            public List<MdlBaseIntId> FnGetAllAssetsSaleWriteOffMasterBaseData()
            {
                List<MdlBaseIntId> lstMdlAssetsSaleWriteOffMasterBaseIntId = new List<MdlBaseIntId>();

                // Get Data from DB
                DataSet objDataSet = this.insDbService.FnExcecuteSqlCommand("SELECT * FROM fn_get_all_assets_sale_write_off_master()");
                if (objDataSet != null)
                {
                    foreach (DataRow objRecord in objDataSet.Tables[0].Rows)
                    {
                        MdlBaseIntId mdlBaseIntId = new MdlBaseIntId();

                        mdlBaseIntId.binPkId = (DBNull.Value != objRecord["pk_assets_sale_Write_off_master_id"]) ? (long)Convert.ToUInt64(objRecord["pk_assets_sale_Write_off_master_id"]) : mdlBaseIntId.binPkId;
                        mdlBaseIntId.strCode = (DBNull.Value != objRecord[""]) ? Convert.ToString(objRecord[""]) : mdlBaseIntId.strCode;
                        mdlBaseIntId.strName = (DBNull.Value != objRecord["vhr_depositor_name"]) ? Convert.ToString(objRecord["vhr_depositor_name"]) : mdlBaseIntId.strName;
        
                        lstMdlAssetsSaleWriteOffMasterBaseIntId.Add(mdlBaseIntId);
                    }
                }

                return lstMdlAssetsSaleWriteOffMasterBaseIntId;
            }
        


            public List<MdlAssetsSaleWriteOffMaster> FnGetAllAssetsSaleWriteOffMasterWithActionUser()
            {
                List<MdlAssetsSaleWriteOffMaster> lstMdlAssetsSaleWriteOffMaster = new List<MdlAssetsSaleWriteOffMaster>();
                
                // Get Data from DB
                DataSet objDataSet = this.insDbService.FnExcecuteSqlCommand("SELECT * FROM fn_get_all_assets_sale_write_off_master_with_action_user()");
                if (objDataSet != null)
                {
                    foreach (DataRow objRecord in objDataSet.Tables[0].Rows)
                    {
                        MdlAssetsSaleWriteOffMaster mdlAssetsSaleWriteOffMaster = new MdlAssetsSaleWriteOffMaster();

                        
				mdlAssetsSaleWriteOffMaster.binAssetsSaleWriteOffMasterId = (DBNull.Value != objRecord["pk_assets_sale_Write_off_master_id"]) ? (long)Convert.ToInt64(objRecord["pk_assets_sale_Write_off_master_id"]) : mdlAssetsSaleWriteOffMaster.binAssetsSaleWriteOffMasterId;
				mdlAssetsSaleWriteOffMaster.binDocumentsId = (DBNull.Value != objRecord["fk_documents_id"]) ? (long)Convert.ToInt64(objRecord["fk_documents_id"]) : mdlAssetsSaleWriteOffMaster.binDocumentsId;
				mdlAssetsSaleWriteOffMaster.binDepreciationMasterId = (DBNull.Value != objRecord["fk_depreciation_master_id"]) ? (long)Convert.ToInt64(objRecord["fk_depreciation_master_id"]) : mdlAssetsSaleWriteOffMaster.binDepreciationMasterId;

				mdlAssetsSaleWriteOffMaster.binCostCentreId = (DBNull.Value != objRecord["fk_cost_centre_id"]) ? (long)Convert.ToInt64(objRecord["fk_cost_centre_id"]) : mdlAssetsSaleWriteOffMaster.binCostCentreId;
				mdlAssetsSaleWriteOffMaster.sinIfSale = (DBNull.Value != objRecord["sin_if_sale"]) ? (short)Convert.ToInt16(objRecord["sin_if_sale"]) : mdlAssetsSaleWriteOffMaster.sinIfSale;

				mdlAssetsSaleWriteOffMaster.binReceivedChequeId = (DBNull.Value != objRecord["fk_received_cheque_id"]) ? (long)Convert.ToInt64(objRecord["fk_received_cheque_id"]) : mdlAssetsSaleWriteOffMaster.binReceivedChequeId;
				mdlAssetsSaleWriteOffMaster.binCcSwapId = (DBNull.Value != objRecord["fk_cc_swap_id"]) ? (long)Convert.ToInt64(objRecord["fk_cc_swap_id"]) : mdlAssetsSaleWriteOffMaster.binCcSwapId;
				mdlAssetsSaleWriteOffMaster.strDepositorName = (DBNull.Value != objRecord["vhr_depositor_name"]) ? Convert.ToString(objRecord["vhr_depositor_name"]) : mdlAssetsSaleWriteOffMaster.strDepositorName;
				mdlAssetsSaleWriteOffMaster.strDepositorRefNo = (DBNull.Value != objRecord["vhr_depositor_ref_no"]) ? Convert.ToString(objRecord["vhr_depositor_ref_no"]) : mdlAssetsSaleWriteOffMaster.strDepositorRefNo;

				mdlAssetsSaleWriteOffMaster.strPayeeVpa = (DBNull.Value != objRecord["vhr_payee_vpa"]) ? Convert.ToString(objRecord["vhr_payee_vpa"]) : mdlAssetsSaleWriteOffMaster.strPayeeVpa;
				mdlAssetsSaleWriteOffMaster.strPayeeVpaBank = (DBNull.Value != objRecord["vhr_payee_vpa_bank"]) ? Convert.ToString(objRecord["vhr_payee_vpa_bank"]) : mdlAssetsSaleWriteOffMaster.strPayeeVpaBank;

				mdlAssetsSaleWriteOffMaster.strVirtualNumber = (DBNull.Value != objRecord["vhr_virtual_number"]) ? Convert.ToString(objRecord["vhr_virtual_number"]) : mdlAssetsSaleWriteOffMaster.strVirtualNumber;
				mdlAssetsSaleWriteOffMaster.strVirtualProvider = (DBNull.Value != objRecord["vhr_virtual_provider"]) ? Convert.ToString(objRecord["vhr_virtual_provider"]) : mdlAssetsSaleWriteOffMaster.strVirtualProvider;
				mdlAssetsSaleWriteOffMaster.strVirtualReference = (DBNull.Value != objRecord["vhr_virtual_reference"]) ? Convert.ToString(objRecord["vhr_virtual_reference"]) : mdlAssetsSaleWriteOffMaster.strVirtualReference;

				mdlAssetsSaleWriteOffMaster.strLedgCurrency = (DBNull.Value != objRecord["vhr_ledg_currency"]) ? Convert.ToString(objRecord["vhr_ledg_currency"]) : mdlAssetsSaleWriteOffMaster.strLedgCurrency;
				mdlAssetsSaleWriteOffMaster.dblLedgCurRoe = (DBNull.Value != objRecord["dbl_ledg_cur_roe"]) ? (double)Convert.ToDouble(objRecord["dbl_ledg_cur_roe"]) : mdlAssetsSaleWriteOffMaster.dblLedgCurRoe;
				mdlAssetsSaleWriteOffMaster.dblLedgCurAmount = (DBNull.Value != objRecord["dbl_ledg_cur_amount"]) ? (double)Convert.ToDouble(objRecord["dbl_ledg_cur_amount"]) : mdlAssetsSaleWriteOffMaster.dblLedgCurAmount;
				mdlAssetsSaleWriteOffMaster.dblLedgCurBankCharge = (DBNull.Value != objRecord["dbl_ledg_cur_bank_charge"]) ? (double)Convert.ToDouble(objRecord["dbl_ledg_cur_bank_charge"]) : mdlAssetsSaleWriteOffMaster.dblLedgCurBankCharge;

				mdlAssetsSaleWriteOffMaster.strBaseCurrency = (DBNull.Value != objRecord["vhr_base_currency"]) ? Convert.ToString(objRecord["vhr_base_currency"]) : mdlAssetsSaleWriteOffMaster.strBaseCurrency;
				mdlAssetsSaleWriteOffMaster.dblBaseCurAmount = (DBNull.Value != objRecord["dbl_base_cur_amount"]) ? (double)Convert.ToDouble(objRecord["dbl_base_cur_amount"]) : mdlAssetsSaleWriteOffMaster.dblBaseCurAmount;
				mdlAssetsSaleWriteOffMaster.dblBaseCurBankCharge = (DBNull.Value != objRecord["dbl_base_cur_bank_charge"]) ? (double)Convert.ToDouble(objRecord["dbl_base_cur_bank_charge"]) : mdlAssetsSaleWriteOffMaster.dblBaseCurBankCharge;

				mdlAssetsSaleWriteOffMaster.binServiceTaxId = (DBNull.Value != objRecord["fk_service_tax_id"]) ? (long)Convert.ToInt64(objRecord["fk_service_tax_id"]) : mdlAssetsSaleWriteOffMaster.binServiceTaxId;
				mdlAssetsSaleWriteOffMaster.dblSysPerceOfTax = (DBNull.Value != objRecord["dbl_sys_perce_of_tax"]) ? (double)Convert.ToDouble(objRecord["dbl_sys_perce_of_tax"]) : mdlAssetsSaleWriteOffMaster.dblSysPerceOfTax;
				mdlAssetsSaleWriteOffMaster.dblPerceOfTax = (DBNull.Value != objRecord["dbl_perce_of_tax"]) ? (double)Convert.ToDouble(objRecord["dbl_perce_of_tax"]) : mdlAssetsSaleWriteOffMaster.dblPerceOfTax;
				mdlAssetsSaleWriteOffMaster.dblLedgCurTaxBaseAmount = (DBNull.Value != objRecord["dbl_ledg_cur_tax_base_amount"]) ? (double)Convert.ToDouble(objRecord["dbl_ledg_cur_tax_base_amount"]) : mdlAssetsSaleWriteOffMaster.dblLedgCurTaxBaseAmount;
				mdlAssetsSaleWriteOffMaster.dblLedgCurTaxAmount = (DBNull.Value != objRecord["dbl_ledg_cur_tax_amount"]) ? (double)Convert.ToDouble(objRecord["dbl_ledg_cur_tax_amount"]) : mdlAssetsSaleWriteOffMaster.dblLedgCurTaxAmount;

				mdlAssetsSaleWriteOffMaster.dblBaseCurTaxBaseAmount = (DBNull.Value != objRecord["dbl_base_cur_tax_base_amount"]) ? (double)Convert.ToDouble(objRecord["dbl_base_cur_tax_base_amount"]) : mdlAssetsSaleWriteOffMaster.dblBaseCurTaxBaseAmount;
				mdlAssetsSaleWriteOffMaster.dblBaseCurTaxAmount = (DBNull.Value != objRecord["dbl_base_cur_tax_amount"]) ? (double)Convert.ToDouble(objRecord["dbl_base_cur_tax_amount"]) : mdlAssetsSaleWriteOffMaster.dblBaseCurTaxAmount;


        
                        lstMdlAssetsSaleWriteOffMaster.Add(mdlAssetsSaleWriteOffMaster);
                    }
                }

                return lstMdlAssetsSaleWriteOffMaster;
            }
        


            public MdlResAssetsSaleWriteOffMaster FnInsertOrUpdateAssetsSaleWriteOffMaster(MdlReqAssetsSaleWriteOffMaster mdlReqAssetsSaleWriteOffMaster)
            {
                // *** Input Validation INSERT and UPDATE Case[not duplicate model validation]
                // ??? Duplication Checking in DB FUCTION(Insert and Update) - CODE, NAME [, other unique fields] Already exists
                // ??? Count Exced or other checking License related in DB FUCTION(Insert)
                // ??? UPDATE Check already update another users in DB FUCTION(Update and Delete)

                // Set Create or modified User in DB FUCTION(Insert, Update and Delete)
                if (mdlReqAssetsSaleWriteOffMaster.mdlAssetsSaleWriteOffMaster.binAssetsSaleWriteOffMasterId == 0)
                {
                    mdlReqAssetsSaleWriteOffMaster.mdlAssetsSaleWriteOffMaster.intSysActionId = 0;
                    mdlReqAssetsSaleWriteOffMaster.mdlAssetsSaleWriteOffMaster.binCreatedUserId = mdlReqAssetsSaleWriteOffMaster.linLoginUserId;
                    mdlReqAssetsSaleWriteOffMaster.mdlAssetsSaleWriteOffMaster.strCreatedUser = mdlReqAssetsSaleWriteOffMaster.strLoginUserName;
                    mdlReqAssetsSaleWriteOffMaster.mdlAssetsSaleWriteOffMaster.dtmCreated = mdlReqAssetsSaleWriteOffMaster.dtmCurrentDateTime;
                }
                else {
                    mdlReqAssetsSaleWriteOffMaster.mdlAssetsSaleWriteOffMaster.binLastModifiedUserId = mdlReqAssetsSaleWriteOffMaster.linLoginUserId;
                    mdlReqAssetsSaleWriteOffMaster.mdlAssetsSaleWriteOffMaster.strLastModifiedUser = mdlReqAssetsSaleWriteOffMaster.strLoginUserName;
                    mdlReqAssetsSaleWriteOffMaster.mdlAssetsSaleWriteOffMaster.dtmLastModified = mdlReqAssetsSaleWriteOffMaster.dtmCurrentDateTime;
                }

                // DB Actions
                NpgsqlParameter[] lstSqlParameter = {
                    new NpgsqlParameter("mdlAssetsSaleWriteOffMaster", NpgsqlDbType.Jsonb) { Value = mdlReqAssetsSaleWriteOffMaster.mdlAssetsSaleWriteOffMaster, DataTypeName = "jsnAssetsSaleWriteOffMaster"},
                    new NpgsqlParameter("jsnSqlRes", NpgsqlDbType.Json) { DataTypeName = "jsnSqlRes", Direction = ParameterDirection.Output }
                };
                MdlDbResponse mdlDbResponse = this.insDbService.FnExcecuteOutSqlCommand("CALL sp_insert_or_update_assetsSaleWriteOffMaster(:mdlAssetsSaleWriteOffMaster, NULL)", lstSqlParameter);
                // DB Error
                if (mdlDbResponse.sinSqlCustomStatus != 1)
                {
                    if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_ERROR")
                    {
                        throw (new TaasDatabaseException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "ASSETSSALEWRITEOFFMASTER.CS#004", mdlDbResponse.strSqlSysMessage)));
                    }
                    else if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_VALIDATION_ERROR")
                    {
                        throw (new TaasDatabaseValidationException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "ASSETSSALEWRITEOFFMASTER.CS#002", mdlDbResponse.strSqlSysMessage)));
                    }
                    else if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_SYSTEM_ERROR")
                    {
                        throw (new TaasDatabaseException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "ASSETSSALEWRITEOFFMASTER.CS#003", mdlDbResponse.strSqlSysMessage)));
                    }
                }

                // Saved
                MdlResAssetsSaleWriteOffMaster mdlResAssetsSaleWriteOffMaster = new MdlResAssetsSaleWriteOffMaster();
                mdlResAssetsSaleWriteOffMaster.mdlAssetsSaleWriteOffMaster = mdlAssetsSaleWriteOffMasterReq.mdlAssetsSaleWriteOffMaster;
                if (mdlReqAssetsSaleWriteOffMaster.mdlAssetsSaleWriteOffMaster.binAssetsSaleWriteOffMasterId == 0)
                {
                    mdlResAssetsSaleWriteOffMaster.mdlAssetsSaleWriteOffMaster.binAssetsSaleWriteOffMasterId = mdlDbResponse.binSqlPk ?? 0;
                    mdlResAssetsSaleWriteOffMaster.mdlAssetsSaleWriteOffMaster.dtmCreated = mdlDbResponse.dtmCurrent;
                }
                else
                {
                    mdlResAssetsSaleWriteOffMaster.mdlAssetsSaleWriteOffMaster.intSysActionId += 1;
                    mdlResAssetsSaleWriteOffMaster.mdlAssetsSaleWriteOffMaster.dtmLastModified = mdlDbResponse.dtmCurrent;
                }
                mdlResAssetsSaleWriteOffMaster.sinStatus = 1;
                mdlResAssetsSaleWriteOffMaster.strStatusCode = "SUCCESS";
                mdlResAssetsSaleWriteOffMaster.strMessage = "ASSETSSALEWRITEOFFMASTER has been Saved.";
                
                return mdlResAssetsSaleWriteOffMaster;
            } 
        


            public MdlResBaseIntId FnDeleteAssetsSaleWriteOffMaster(MdlReqBaseIntId mdlReqAssetsSaleWriteOffMasterBaseIntId)
            {
                // *** Input Validation DELETE Case[not duplicate model validation]
                // ??? FOREIGN KEY REFERENCES Ching in DB FUCTION(Delete)
                // ??? UPDATE Check already update another users in DB FUCTION(Update and Delete)
                // ??? Set Create or modified User in DB FUCTION(Insert, Update and Delete)

                // DB Actions
                NpgsqlParameter[] lstSqlParameter = {
                    new NpgsqlParameter("binAssetsSaleWriteOffMasterId", NpgsqlDbType.Bigint) { Value = mdlReqAssetsSaleWriteOffMasterBaseIntId.mdlBaseIntId.binPkId, DataTypeName = "binAssetsSaleWriteOffMasterId"},
                    new NpgsqlParameter("intSysActionId", NpgsqlDbType.Integer) { Value = mdlReqAssetsSaleWriteOffMasterBaseIntId.mdlBaseIntId.binCustomValue, DataTypeName = "intSysActionId"},
                    new NpgsqlParameter("binDeletedUserId", NpgsqlDbType.Bigint) { Value = mdlReqAssetsSaleWriteOffMasterBaseIntId.linLoginUserId, DataTypeName = "binDeletedUserId"},
                    new NpgsqlParameter("jsnSqlRes", NpgsqlDbType.Json) { DataTypeName = "jsnSqlRes", Direction = ParameterDirection.Output }
                };
                MdlDbResponse mdlDbResponse = this.insDbService.FnExcecuteOutSqlCommand("CALL sp_delete_assetsSaleWriteOffMaster(:binAssetsSaleWriteOffMasterId, :intSysActionId, :binDeletedUserId, NULL)", lstSqlParameter);
                // DB Error
                if (mdlDbResponse.sinSqlCustomStatus != 1)
                {
                    if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_ERROR")
                    {
                        throw (new TaasDatabaseException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "ASSETSSALEWRITEOFFMASTER.CS#004", mdlDbResponse.strSqlSysMessage)));
                    }
                    else if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_VALIDATION_ERROR")
                    {
                        throw (new TaasDatabaseValidationException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "ASSETSSALEWRITEOFFMASTER.CS#005", mdlDbResponse.strSqlSysMessage)));
                    }
                    else if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_SYSTEM_ERROR")
                    {
                        throw (new TaasDatabaseException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "ASSETSSALEWRITEOFFMASTER.CS#006", mdlDbResponse.strSqlSysMessage)));
                    }
                }

                // Deleted
                MdlResBaseIntId mdlResAssetsSaleWriteOffMasterIntId = new MdlResBaseIntId();

                mdlResAssetsSaleWriteOffMasterIntId.mdlBaseIntId = mdlReqAssetsSaleWriteOffMasterBaseIntId.mdlBaseIntId;
                mdlResAssetsSaleWriteOffMasterIntId.sinStatus = 1;
                mdlResAssetsSaleWriteOffMasterIntId.strStatusCode = "SUCCESS";
                mdlResAssetsSaleWriteOffMasterIntId.strMessage = "ASSETSSALEWRITEOFFMASTER has been deleted.";

                return mdlResAssetsSaleWriteOffMasterIntId;
            }
        

