???File Path
==========
***...\ClientApp\src\app\src\assets\assets-sale-writeOff-details\assets-sale-writeOff-details.component.ts\n\n\n???Check the points
==================
1) Check ...\ClientApp\src\app\src\base\branch\branch.component.ts and ...\ClientApp\src\app\src\base\company\company.component.ts \n2) Main Grouping Must
	-> // @@@@@@@ AREA=> FROM HTML INPUT AREA Called Functions(Not Button bar and List) @@@@@@@@@@@@@@
	-> // @@@@@@@ FROM HTML MAIN LIST Called Functions @@@@@@@@@@@@@@
	-> // @@@@@@@ AREA=> FROM HTML BUTTON BAR Called Functions @@@@@@@@@@@@@@
	-> // @@@@@@@ AREA=> COMMON Functions @@@@@@@@@@@@@@
3) Set GUI Heading in constructor(Eg:- insGlobalConstants.strGuiHeading = "***";)
4) Set GUI/Menu System Name in constructor(Eg:- insGlobalConstants.strSysModuleName = "***";) based on menu service
5) Set GUI Tittle(Browser Tab) in constructor(Eg:- insGlobalFunctions.fnSetGuiBasedBrowserTitle = "***";)



            // ??? Check and Use If you need...
            //---------------------------------
            import { Component, OnInit, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
            import { DxDataGridComponent } from "devextreme-angular";

            import * as globalConstantsService from '../../../services/global-constants.service';
            import * as globalFunctionsService from '../../../services/global-functions.service';
            import * as globalDataService from '../../../services/global-data.service';
            import * as baseDataService from '../../../services/base/base-data.service';
            import * as jspdfService from '../../../services/jspdf.service';
            import * as menuService from '../../../services/menu.service';
            import { MdlAssetsSaleWriteOffDetails, MdlReqAssetsSaleWriteOffDetails, MdlResAssetsSaleWriteOffDetails, MdlResAssetsSaleWriteOffDetailsInit, MdlResAssetsSaleWriteOffDetailsList } from '../../../models/assets/assets.model';
            import { MdlResponse, MdlBaseIntId, MdlReqBaseIntId } from "../../../models/common.model";
            import { HttpService } from '../../../services/http.service';
        


            // ??? Check and Use If you need...
            //---------------------------------
            export class AssetsSaleWriteOffDetailsComponent implements OnInit, AfterViewInit, OnDestroy {
                // ** initialize data
                public mdlAssetsSaleWriteOffDetails: MdlAssetsSaleWriteOffDetails = new MdlAssetsSaleWriteOffDetails();
                public intActiveAssetsSaleWriteOffDetailsIndex: number = -1;
                // ** Select and Auto-completion
                // ??? Remove not use items !!!
			lstMdlAssetsSaleWriteOffMasterBaseIntId: MdlBaseIntId[] = [];
			lstMdlAssetsBaseIntId: MdlBaseIntId[] = [];

                // ** GUI Control
                public blnBtnDisabled: boolean = false;
                public blnMoreDivExpanded: boolean = false;
                // ** AssetsSaleWriteOffDetails List
                @ViewChild('#idDgAssetsSaleWriteOffDetailsList') idDgAssetsSaleWriteOffDetailsList!: DxDataGridComponent;
                public lstAllAssetsSaleWriteOffDetails: MdlAssetsSaleWriteOffDetails[] = [];
                public blnDgAssetsSaleWriteOffDetailsShowFilterRow: boolean = false;
                public blnDgAssetsSaleWriteOffDetailsHeaderFilter: boolean = false;
                public intActiveAssetsSaleWriteOffDetailsListItemIndex = -1;
        


                // ??? If you need, import and create instance other common classes !!!
                constructor(public insGlobalConstants: globalConstantsService.GlobalConstantsService,
                        public insGlobalFunctions: globalFunctionsService.GlobalFunctionsService,
                        public insGlobalData: globalDataService.GlobalDataService,
                        public insBaseData: baseDataService.BaseDataService,
                        private insHttpService: HttpService,
                        public insJspdf: jspdfService.JspdfService) {
    
                    insGlobalConstants.strGuiHeading = 'assetsSaleWriteOffDetails';
                    // ??? Check menu service !!!
                    insGlobalConstants.strSysModuleName = "ASSETSSALEWRITEOFFDETAILS_MASTER";
                    insGlobalFunctions.fnSetGuiBasedBrowserTitle("AssetsSaleWriteOffDetails");
                }

                ngOnInit(): void {
                    this.blnBtnDisabled = true;
                    document.body.style.cursor = "wait";

                    this.fnDefaultView();

                    // initialize Data Request
                    this.insHttpService.get('Base/Organization/GetAssetsSaleWriteOffDetailsInitializeData')
                    .then((mdlResAssetsSaleWriteOffDetailsInit: MdlResAssetsSaleWriteOffDetailsInit) => {
                        if (mdlResAssetsSaleWriteOffDetailsInit.sinStatus == 1) {
                            this.lstMdlAssetsSaleWriteOffDetails = mdlResAssetsSaleWriteOffDetailsInit.lstMdlAssetsSaleWriteOffDetails;

                            // ??? Remove not use items !!!
					this.lstMdlAssetsSaleWriteOffMasterBaseIntId = mdlResAssetsSaleWriteOffDetailsInit.lstMdlAssetsSaleWriteOffMasterBaseIntId;
					this.lstMdlAssetsBaseIntId = mdlResAssetsSaleWriteOffDetailsInit.lstMdlAssetsBaseIntId;

                        } else {
                            console.log(mdlResAssetsSaleWriteOffDetailsInit.strMessage + " => " + mdlResAssetsSaleWriteOffDetailsInit.strErrorCode + ' -> ' + mdlResAssetsSaleWriteOffDetailsInit.strSysError);
                        }
                    })
                    .catch((err: any) => {
                        console.log("Error->ASSETSSALEWRITEOFFDETAILS.COMPONENT.TS#001: " + JSON.stringify(err));
                    });

                    document.body.style.cursor = "default";
                    this.blnBtnDisabled = false;
                }

                ngAfterViewInit(): void {
                }

                ngOnDestroy() {
                }
        


            // @@@@@@@ AREA=> FROM HTML INPUT AREA Called Functions(Not Button bar and List) @@@@@@@@@@@@@


            // ??? AUTO/ENTRY COMPLETE - Set Id[, Code, Name] -> OnFocusOut Event

            // ??? Any caculation/Display Based on user inputs

        


            // @@@@@@@@@@@@@@@@@@@@@@@ AREA=> FROM HTML MAIN LIST Called Functions @@@@@@@@@@@@@@@@@@@@@@@@

            fnOnAssetsSaleWriteOffDetailsListEditButtonClick(objSelRow: any) {
                this.blnBtnDisabled = true;
                document.body.style.cursor = "wait";

                this.fnSetDataAndGuiEditMode(objSelRow.row.data, objSelRow.row.rowIndex);

                document.body.style.cursor = "default";
                this.blnBtnDisabled = false;
            }

            fnOnAssetsSaleWriteOffDetailsListRowDblClick(objDblClickRowData: any) {
                this.blnBtnDisabled = true;
                document.body.style.cursor = "wait";

                this.fnSetDataAndGuiEditMode(objDblClickRowData.data, objDblClickRowData.rowIndex);

                document.body.style.cursor = "default";
                this.blnBtnDisabled = false;
            }

            fnOnDgFilterRowEnableDisableClick() {
                this.blnDgShowFilterRow = !this.blnDgShowFilterRow;
            }

            fnOnDgHeadeFilterEnableDisableClick() {
                this.blnDgHeaderFilter = !this.blnDgHeaderFilter;
            }
        


            // @@@@@@@@@@@@@@@@@@@@@@ AREA=> FROM HTML BUTTON BAR Called Functions @@@@@@@@@@@@@@@@@@@@@@@@

            async fnOnSaveButtonClick() {
            this.blnBtnDisabled = true;
            document.body.style.cursor = "wait";
            this.fnDefaultView(false, true, true, false);

            // Add or Update 
            try {
            // Input Validation
            this.fnInputValidation(this.mdlAssetsSaleWriteOffDetails);

            // Input Data set
            //....

            // Set Save Request Inputs
            let mdlReqAssetsSaleWriteOffDetails: MdlReqAssetsSaleWriteOffDetails = new MdlReqAssetsSaleWriteOffDetails();
            mdlReqAssetsSaleWriteOffDetails.mdlAssetsSaleWriteOffDetails = JSON.parse(JSON.stringify(this.mdlAssetsSaleWriteOffDetails));

            // Request Data Reset
            //....

            // Save Request
            await this.insHttpService.post('Base/Organization/SaveAssetsSaleWriteOffDetails', mdlReqAssetsSaleWriteOffDetails)
                .then((mdlResAssetsSaleWriteOffDetails: MdlResAssetsSaleWriteOffDetails) => {
                if (mdlResAssetsSaleWriteOffDetails.sinStatus == 1) {
                    this.mdlAssetsSaleWriteOffDetails = mdlResAssetsSaleWriteOffDetails.mdlAssetsSaleWriteOffDetails;
                    if (this.intActiveAssetsSaleWriteOffDetailsIndex == -1) {
                    // New Item
                    this.intActiveAssetsSaleWriteOffDetailsIndex = this.lstMdlAssetsSaleWriteOffDetails.length;
                    this.lstMdlAssetsSaleWriteOffDetails.push(JSON.parse(JSON.stringify(this.mdlAssetsSaleWriteOffDetails)));
                    }
                    else {
                    // Update
                    this.lstMdlAssetsSaleWriteOffDetails[this.intActiveAssetsSaleWriteOffDetailsIndex] = JSON.parse(JSON.stringify(this.mdlAssetsSaleWriteOffDetails));
                    //this.lstMdlAssetsSaleWriteOffDetails.splice(this.intActiveAssetsSaleWriteOffDetailsIndex, 1, this.mdlAssetsSaleWriteOffDetails);
                    }

                    this.insGlobalConstants.fnSetSuccessMessage(mdlResAssetsSaleWriteOffDetails.strMessage);
                } else {
                    this.insGlobalConstants.fnSetErrorMessage(mdlResAssetsSaleWriteOffDetails.strMessage, mdlResAssetsSaleWriteOffDetails.strSysError);
                    console.log(mdlResAssetsSaleWriteOffDetails);
                }
                })
                .catch((err: any) => {
                    this.insGlobalConstants.fnSetErrorMessage(JSON.stringify(err));
                });

            } catch (ex: unknown) {
                if (ex instanceof Error) {
                    //this.insGlobalConstants.strErrorMessages = ex.message;
                    this.insGlobalConstants.fnSetErrorMessage(ex.message);
                }
                console.log("Error->ASSETSSALEWRITEOFFDETAILS.COMPONENT.TS#002: " + ex);
            }

            this.fnDefaultView(false, false, true, false);
            document.body.style.cursor = "default";
            this.blnBtnDisabled = false;
        }

        fnOnNewButtonClick() {
            this.blnBtnDisabled = true;
            document.body.style.cursor = "wait";

            this.fnDefaultView(true, true, true, false);

            document.body.style.cursor = "default";
            this.blnBtnDisabled = false;
        }

        async fnOnDeleteButtonClick() {
            this.blnBtnDisabled = true;
            document.body.style.cursor = "wait";
            this.fnDefaultView(false, true, false, false);

            // Delete 
            try {

            // Input Validation
            if (this.mdlAssetsSaleWriteOffDetails.binAssetsSaleWriteOffId == null || this.mdlAssetsSaleWriteOffDetails.binAssetsSaleWriteOffId < 1) {
                throw new Error('Select AssetsSaleWriteOffDetails for DELETE.');
            }

            // Set Delete Request Inputs
            let mdlReqAssetsSaleWriteOffDetailsBaseIntId: MdlReqBaseIntId = new MdlReqBaseIntId();
            mdlReqAssetsSaleWriteOffDetailsBaseIntId.mdlBaseIntId.binPkId = this.mdlAssetsSaleWriteOffDetails.binAssetsSaleWriteOffId;
            mdlReqAssetsSaleWriteOffDetailsBaseIntId.mdlBaseIntId.binCustomValue = this.mdlAssetsSaleWriteOffDetails.intSysActionId;
            
            // Delete Request
            await this.insHttpService.post('Base/Organization/DeleteAssetsSaleWriteOffDetails', mdlReqAssetsSaleWriteOffDetailsBaseIntId)
                .then((mdlResponse: MdlResponse) => {
                if (mdlResponse.sinStatus == 1) {
                    this.lstMdlAssetsSaleWriteOffDetails.splice(this.intActiveAssetsSaleWriteOffDetailsIndex, 1);
                    this.fnDefaultView(true, false, false, false);
                    this.insGlobalConstants.fnSetSuccessMessage(mdlResponse.strMessage);
                } else {
                    this.insGlobalConstants.fnSetErrorMessage(mdlResponse.strMessage, mdlResponse.strSysError);
                    console.log(mdlResponse);
                }
                })
                .catch((err: any) => {
                this.insGlobalConstants.fnSetErrorMessage(JSON.stringify(err));
                });

            } catch (ex: unknown) {
            if (ex instanceof Error) {
                this.insGlobalConstants.fnSetErrorMessage(ex.message);
            }
            console.log("Error->ASSETSSALEWRITEOFFDETAILS.COMPONENT.TS#003: " + ex);
            }

            document.body.style.cursor = "default";
            this.blnBtnDisabled = false;
        }

        


            // @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ AREA=> COMMON Functions @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@


            fnDefaultView(blnClearData: boolean = true, blnClearMessages: boolean = true, blnMoreDivExpanded: boolean = false, blnGotoBottom: boolean = false) {
                if (blnClearData) {
                    this.mdlAssetsSaleWriteOffDetails = new MdlAssetsSaleWriteOffDetails();
                    this.intActiveAssetsSaleWriteOffDetailsIndex = -1;
                }

                this.blnMoreDivExpanded = blnMoreDivExpanded;

                if (blnClearMessages) {
                    this.insGlobalConstants.strErrorMessages = "";
                    this.insGlobalConstants.strSuccessMessages = "";
                }
                
                if (!blnGotoBottom)
                    this.insGlobalFunctions.fnWindowScrollTop();
                else {
                    this.insGlobalFunctions.fnWindowScrollbottom();
                }
            }

            fnSetDataAndGuiEditMode(mdlAssetsSaleWriteOffDetails: MdlAssetsSaleWriteOffDetails, intRowIndex: number) {
                this.mdlAssetsSaleWriteOffDetails = JSON.parse(JSON.stringify(mdlAssetsSaleWriteOffDetails));
                this.intActiveAssetsSaleWriteOffDetailsIndex = intRowIndex;
                this.fnDefaultView(false, true, true, false);
            }

            fnInputValidation(mdlAssetsSaleWriteOffDetails: MdlAssetsSaleWriteOffDetails) {
                // ??? CHECK
                
                if (mdlAssetsSaleWriteOffDetails.binAssetsSaleWriteOffMasterId == 0) {
                    throw new Error('Enter/Select Assets Sale Write Off Master.');
                }
            
                if (mdlAssetsSaleWriteOffDetails.binAssetsId == 0) {
                    throw new Error('Enter/Select Assets.');
                }
            
                if (mdlAssetsSaleWriteOffDetails.strLedgCurrency == "") {
                    throw new Error('Enter/Select Ledg Currency.');
                }
            
                if (mdlAssetsSaleWriteOffDetails.strBaseCurrency == "") {
                    throw new Error('Enter/Select Base Currency.');
                }
            
                if (mdlAssetsSaleWriteOffDetails.strAssetsLedgCurrency == "") {
                    throw new Error('Enter/Select Assets Ledg Currency.');
                }
            
                if (mdlAssetsSaleWriteOffDetails.strAssetsBaseCurrency == "") {
                    throw new Error('Enter/Select Assets Base Currency.');
                }
            

                // ??? CHECK CODE and NAME [Other UNIQUE Fields] Already exists
            }
        

