???File Path
==========
***...\ClientApp\src\app\src\assets\assets-sale-writeOff-master\assets-sale-writeOff-master.component.ts\n\n\n???Check the points
==================
1) Check ...\ClientApp\src\app\src\base\branch\branch.component.ts and ...\ClientApp\src\app\src\base\company\company.component.ts \n2) Main Grouping Must
	-> // @@@@@@@ AREA=> FROM HTML INPUT AREA Called Functions(Not Button bar and List) @@@@@@@@@@@@@@
	-> // @@@@@@@ FROM HTML MAIN LIST Called Functions @@@@@@@@@@@@@@
	-> // @@@@@@@ AREA=> FROM HTML BUTTON BAR Called Functions @@@@@@@@@@@@@@
	-> // @@@@@@@ AREA=> COMMON Functions @@@@@@@@@@@@@@
3) Set GUI Heading in constructor(Eg:- insGlobalConstants.strGuiHeading = "***";)
4) Set GUI/Menu System Name in constructor(Eg:- insGlobalConstants.strSysModuleName = "***";) based on menu service
5) Set GUI Tittle(Browser Tab) in constructor(Eg:- insGlobalFunctions.fnSetGuiBasedBrowserTitle = "***";)



            // ??? Check and Use If you need...
            //---------------------------------
            import { Component, OnInit, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
            import { DxDataGridComponent } from "devextreme-angular";

            import * as globalConstantsService from '../../../services/global-constants.service';
            import * as globalFunctionsService from '../../../services/global-functions.service';
            import * as globalDataService from '../../../services/global-data.service';
            import * as baseDataService from '../../../services/base/base-data.service';
            import * as jspdfService from '../../../services/jspdf.service';
            import * as menuService from '../../../services/menu.service';
            import { MdlAssetsSaleWriteOffMaster, MdlReqAssetsSaleWriteOffMaster, MdlResAssetsSaleWriteOffMaster, MdlResAssetsSaleWriteOffMasterInit, MdlResAssetsSaleWriteOffMasterList } from '../../../models/assets/assets.model';
            import { MdlResponse, MdlBaseIntId, MdlReqBaseIntId } from "../../../models/common.model";
            import { HttpService } from '../../../services/http.service';
        


            // ??? Check and Use If you need...
            //---------------------------------
            export class AssetsSaleWriteOffMasterComponent implements OnInit, AfterViewInit, OnDestroy {
                // ** initialize data
                public mdlAssetsSaleWriteOffMaster: MdlAssetsSaleWriteOffMaster = new MdlAssetsSaleWriteOffMaster();
                public intActiveAssetsSaleWriteOffMasterIndex: number = -1;
                // ** Select and Auto-completion
                // ??? Remove not use items !!!
			lstMdlDocumentsBaseIntId: MdlBaseIntId[] = [];
			lstMdlDepreciationMasterBaseIntId: MdlBaseIntId[] = [];
			lstMdlCostCentreBaseIntId: MdlBaseIntId[] = [];
			lstMdlReceivedChequeBaseIntId: MdlBaseIntId[] = [];
			lstMdlCcSwapBaseIntId: MdlBaseIntId[] = [];
			lstMdlServiceTaxBaseIntId: MdlBaseIntId[] = [];

                // ** GUI Control
                public blnBtnDisabled: boolean = false;
                public blnMoreDivExpanded: boolean = false;
                // ** AssetsSaleWriteOffMaster List
                @ViewChild('#idDgAssetsSaleWriteOffMasterList') idDgAssetsSaleWriteOffMasterList!: DxDataGridComponent;
                public lstAllAssetsSaleWriteOffMaster: MdlAssetsSaleWriteOffMaster[] = [];
                public blnDgAssetsSaleWriteOffMasterShowFilterRow: boolean = false;
                public blnDgAssetsSaleWriteOffMasterHeaderFilter: boolean = false;
                public intActiveAssetsSaleWriteOffMasterListItemIndex = -1;
        


                // ??? If you need, import and create instance other common classes !!!
                constructor(public insGlobalConstants: globalConstantsService.GlobalConstantsService,
                        public insGlobalFunctions: globalFunctionsService.GlobalFunctionsService,
                        public insGlobalData: globalDataService.GlobalDataService,
                        public insBaseData: baseDataService.BaseDataService,
                        private insHttpService: HttpService,
                        public insJspdf: jspdfService.JspdfService) {
    
                    insGlobalConstants.strGuiHeading = 'assetsSaleWriteOffMaster';
                    // ??? Check menu service !!!
                    insGlobalConstants.strSysModuleName = "ASSETSSALEWRITEOFFMASTER_MASTER";
                    insGlobalFunctions.fnSetGuiBasedBrowserTitle("AssetsSaleWriteOffMaster");
                }

                ngOnInit(): void {
                    this.blnBtnDisabled = true;
                    document.body.style.cursor = "wait";

                    this.fnDefaultView();

                    // initialize Data Request
                    this.insHttpService.get('Base/Organization/GetAssetsSaleWriteOffMasterInitializeData')
                    .then((mdlResAssetsSaleWriteOffMasterInit: MdlResAssetsSaleWriteOffMasterInit) => {
                        if (mdlResAssetsSaleWriteOffMasterInit.sinStatus == 1) {
                            this.lstMdlAssetsSaleWriteOffMaster = mdlResAssetsSaleWriteOffMasterInit.lstMdlAssetsSaleWriteOffMaster;

                            // ??? Remove not use items !!!
					this.lstMdlDocumentsBaseIntId = mdlResAssetsSaleWriteOffMasterInit.lstMdlDocumentsBaseIntId;
					this.lstMdlDepreciationMasterBaseIntId = mdlResAssetsSaleWriteOffMasterInit.lstMdlDepreciationMasterBaseIntId;
					this.lstMdlCostCentreBaseIntId = mdlResAssetsSaleWriteOffMasterInit.lstMdlCostCentreBaseIntId;
					this.lstMdlReceivedChequeBaseIntId = mdlResAssetsSaleWriteOffMasterInit.lstMdlReceivedChequeBaseIntId;
					this.lstMdlCcSwapBaseIntId = mdlResAssetsSaleWriteOffMasterInit.lstMdlCcSwapBaseIntId;
					this.lstMdlServiceTaxBaseIntId = mdlResAssetsSaleWriteOffMasterInit.lstMdlServiceTaxBaseIntId;

                        } else {
                            console.log(mdlResAssetsSaleWriteOffMasterInit.strMessage + " => " + mdlResAssetsSaleWriteOffMasterInit.strErrorCode + ' -> ' + mdlResAssetsSaleWriteOffMasterInit.strSysError);
                        }
                    })
                    .catch((err: any) => {
                        console.log("Error->ASSETSSALEWRITEOFFMASTER.COMPONENT.TS#001: " + JSON.stringify(err));
                    });

                    document.body.style.cursor = "default";
                    this.blnBtnDisabled = false;
                }

                ngAfterViewInit(): void {
                }

                ngOnDestroy() {
                }
        


            // @@@@@@@ AREA=> FROM HTML INPUT AREA Called Functions(Not Button bar and List) @@@@@@@@@@@@@


            // ??? AUTO/ENTRY COMPLETE - Set Id[, Code, Name] -> OnFocusOut Event

            // ??? Any caculation/Display Based on user inputs

        


            // @@@@@@@@@@@@@@@@@@@@@@@ AREA=> FROM HTML MAIN LIST Called Functions @@@@@@@@@@@@@@@@@@@@@@@@

            fnOnAssetsSaleWriteOffMasterListEditButtonClick(objSelRow: any) {
                this.blnBtnDisabled = true;
                document.body.style.cursor = "wait";

                this.fnSetDataAndGuiEditMode(objSelRow.row.data, objSelRow.row.rowIndex);

                document.body.style.cursor = "default";
                this.blnBtnDisabled = false;
            }

            fnOnAssetsSaleWriteOffMasterListRowDblClick(objDblClickRowData: any) {
                this.blnBtnDisabled = true;
                document.body.style.cursor = "wait";

                this.fnSetDataAndGuiEditMode(objDblClickRowData.data, objDblClickRowData.rowIndex);

                document.body.style.cursor = "default";
                this.blnBtnDisabled = false;
            }

            fnOnDgFilterRowEnableDisableClick() {
                this.blnDgShowFilterRow = !this.blnDgShowFilterRow;
            }

            fnOnDgHeadeFilterEnableDisableClick() {
                this.blnDgHeaderFilter = !this.blnDgHeaderFilter;
            }
        


            // @@@@@@@@@@@@@@@@@@@@@@ AREA=> FROM HTML BUTTON BAR Called Functions @@@@@@@@@@@@@@@@@@@@@@@@

            async fnOnSaveButtonClick() {
            this.blnBtnDisabled = true;
            document.body.style.cursor = "wait";
            this.fnDefaultView(false, true, true, false);

            // Add or Update 
            try {
            // Input Validation
            this.fnInputValidation(this.mdlAssetsSaleWriteOffMaster);

            // Input Data set
            //....

            // Set Save Request Inputs
            let mdlReqAssetsSaleWriteOffMaster: MdlReqAssetsSaleWriteOffMaster = new MdlReqAssetsSaleWriteOffMaster();
            mdlReqAssetsSaleWriteOffMaster.mdlAssetsSaleWriteOffMaster = JSON.parse(JSON.stringify(this.mdlAssetsSaleWriteOffMaster));

            // Request Data Reset
            //....

            // Save Request
            await this.insHttpService.post('Base/Organization/SaveAssetsSaleWriteOffMaster', mdlReqAssetsSaleWriteOffMaster)
                .then((mdlResAssetsSaleWriteOffMaster: MdlResAssetsSaleWriteOffMaster) => {
                if (mdlResAssetsSaleWriteOffMaster.sinStatus == 1) {
                    this.mdlAssetsSaleWriteOffMaster = mdlResAssetsSaleWriteOffMaster.mdlAssetsSaleWriteOffMaster;
                    if (this.intActiveAssetsSaleWriteOffMasterIndex == -1) {
                    // New Item
                    this.intActiveAssetsSaleWriteOffMasterIndex = this.lstMdlAssetsSaleWriteOffMaster.length;
                    this.lstMdlAssetsSaleWriteOffMaster.push(JSON.parse(JSON.stringify(this.mdlAssetsSaleWriteOffMaster)));
                    }
                    else {
                    // Update
                    this.lstMdlAssetsSaleWriteOffMaster[this.intActiveAssetsSaleWriteOffMasterIndex] = JSON.parse(JSON.stringify(this.mdlAssetsSaleWriteOffMaster));
                    //this.lstMdlAssetsSaleWriteOffMaster.splice(this.intActiveAssetsSaleWriteOffMasterIndex, 1, this.mdlAssetsSaleWriteOffMaster);
                    }

                    this.insGlobalConstants.fnSetSuccessMessage(mdlResAssetsSaleWriteOffMaster.strMessage);
                } else {
                    this.insGlobalConstants.fnSetErrorMessage(mdlResAssetsSaleWriteOffMaster.strMessage, mdlResAssetsSaleWriteOffMaster.strSysError);
                    console.log(mdlResAssetsSaleWriteOffMaster);
                }
                })
                .catch((err: any) => {
                    this.insGlobalConstants.fnSetErrorMessage(JSON.stringify(err));
                });

            } catch (ex: unknown) {
                if (ex instanceof Error) {
                    //this.insGlobalConstants.strErrorMessages = ex.message;
                    this.insGlobalConstants.fnSetErrorMessage(ex.message);
                }
                console.log("Error->ASSETSSALEWRITEOFFMASTER.COMPONENT.TS#002: " + ex);
            }

            this.fnDefaultView(false, false, true, false);
            document.body.style.cursor = "default";
            this.blnBtnDisabled = false;
        }

        fnOnNewButtonClick() {
            this.blnBtnDisabled = true;
            document.body.style.cursor = "wait";

            this.fnDefaultView(true, true, true, false);

            document.body.style.cursor = "default";
            this.blnBtnDisabled = false;
        }

        async fnOnDeleteButtonClick() {
            this.blnBtnDisabled = true;
            document.body.style.cursor = "wait";
            this.fnDefaultView(false, true, false, false);

            // Delete 
            try {

            // Input Validation
            if (this.mdlAssetsSaleWriteOffMaster.binAssetsSaleWriteOffMasterId == null || this.mdlAssetsSaleWriteOffMaster.binAssetsSaleWriteOffMasterId < 1) {
                throw new Error('Select AssetsSaleWriteOffMaster for DELETE.');
            }

            // Set Delete Request Inputs
            let mdlReqAssetsSaleWriteOffMasterBaseIntId: MdlReqBaseIntId = new MdlReqBaseIntId();
            mdlReqAssetsSaleWriteOffMasterBaseIntId.mdlBaseIntId.binPkId = this.mdlAssetsSaleWriteOffMaster.binAssetsSaleWriteOffMasterId;
            mdlReqAssetsSaleWriteOffMasterBaseIntId.mdlBaseIntId.binCustomValue = this.mdlAssetsSaleWriteOffMaster.intSysActionId;
            
            // Delete Request
            await this.insHttpService.post('Base/Organization/DeleteAssetsSaleWriteOffMaster', mdlReqAssetsSaleWriteOffMasterBaseIntId)
                .then((mdlResponse: MdlResponse) => {
                if (mdlResponse.sinStatus == 1) {
                    this.lstMdlAssetsSaleWriteOffMaster.splice(this.intActiveAssetsSaleWriteOffMasterIndex, 1);
                    this.fnDefaultView(true, false, false, false);
                    this.insGlobalConstants.fnSetSuccessMessage(mdlResponse.strMessage);
                } else {
                    this.insGlobalConstants.fnSetErrorMessage(mdlResponse.strMessage, mdlResponse.strSysError);
                    console.log(mdlResponse);
                }
                })
                .catch((err: any) => {
                this.insGlobalConstants.fnSetErrorMessage(JSON.stringify(err));
                });

            } catch (ex: unknown) {
            if (ex instanceof Error) {
                this.insGlobalConstants.fnSetErrorMessage(ex.message);
            }
            console.log("Error->ASSETSSALEWRITEOFFMASTER.COMPONENT.TS#003: " + ex);
            }

            document.body.style.cursor = "default";
            this.blnBtnDisabled = false;
        }

        


            // @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ AREA=> COMMON Functions @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@


            fnDefaultView(blnClearData: boolean = true, blnClearMessages: boolean = true, blnMoreDivExpanded: boolean = false, blnGotoBottom: boolean = false) {
                if (blnClearData) {
                    this.mdlAssetsSaleWriteOffMaster = new MdlAssetsSaleWriteOffMaster();
                    this.intActiveAssetsSaleWriteOffMasterIndex = -1;
                }

                this.blnMoreDivExpanded = blnMoreDivExpanded;

                if (blnClearMessages) {
                    this.insGlobalConstants.strErrorMessages = "";
                    this.insGlobalConstants.strSuccessMessages = "";
                }
                
                if (!blnGotoBottom)
                    this.insGlobalFunctions.fnWindowScrollTop();
                else {
                    this.insGlobalFunctions.fnWindowScrollbottom();
                }
            }

            fnSetDataAndGuiEditMode(mdlAssetsSaleWriteOffMaster: MdlAssetsSaleWriteOffMaster, intRowIndex: number) {
                this.mdlAssetsSaleWriteOffMaster = JSON.parse(JSON.stringify(mdlAssetsSaleWriteOffMaster));
                this.intActiveAssetsSaleWriteOffMasterIndex = intRowIndex;
                this.fnDefaultView(false, true, true, false);
            }

            fnInputValidation(mdlAssetsSaleWriteOffMaster: MdlAssetsSaleWriteOffMaster) {
                // ??? CHECK
                
                if (mdlAssetsSaleWriteOffMaster.binDocumentsId == 0) {
                    throw new Error('Enter/Select Documents.');
                }
            
                if (mdlAssetsSaleWriteOffMaster.strLedgCurrency == "") {
                    throw new Error('Enter/Select Ledg Currency.');
                }
            
                if (mdlAssetsSaleWriteOffMaster.strBaseCurrency == "") {
                    throw new Error('Enter/Select Base Currency.');
                }
            

                // ??? CHECK CODE and NAME [Other UNIQUE Fields] Already exists
            }
        

